/*
 This is part of the OTF library. Copyright by ZIH, TU Dresden 2005-2006.
 Authors: Andreas Knuepfer, Holger Brunst, Ronny Brendel, Thomas Kriebitzsch
*/

#ifndef OTF_DEFINITIONS_H
#define OTF_DEFINITIONS_H


/* version information */

#define OTF_VERSION_MAYOR	1
#define OTF_VERSION_MINOR	2
#define OTF_VERSION_SUB 	6
#define OTF_VERSION_STRING	"pufferfish"

/* version history:

0.2.1 	"octopussy"
0.3.1 	"starfish"
0.3.2 	"starfish"
0.4.0 	"starfish"
0.4.1 	"starfish"
0.5.0	"starfish"
1.0.*	"starfish"
1.1.*	"starfish"
1.2.*	"pufferfish"

*/


/* definitions of record type identifiers */


/* Event records*/

#define OTF_EVENTCOMMENT_RECORD			0
#define OTF_COUNTER_RECORD				1
#define OTF_ENTER_RECORD				2

#define OTF_COLLOP_RECORD				5

#define OTF_RECEIVE_RECORD				10
#define OTF_SEND_RECORD					11
#define OTF_LEAVE_RECORD				12


/* Definition records*/

#define OTF_DEFTIMERRESOLUTION_RECORD	13
#define OTF_DEFPROCESS_RECORD			14
#define OTF_DEFPROCESSGROUP_RECORD		15
#define OTF_DEFFUNCTION_RECORD			16
#define OTF_DEFFUNCTIONGROUP_RECORD		17
#define OTF_DEFCOUNTER_RECORD			18
#define OTF_DEFCOUNTERGROUP_RECORD		19
#define OTF_DEFCOLLOP_RECORD			20
#define OTF_DEFSCL_RECORD				21
#define OTF_DEFSCLFILE_RECORD			22
#define OTF_DEFVERSION_RECORD			23
#define OTF_DEFCREATOR_RECORD			24


#define OTF_FUNCTIONSUMMARY_RECORD		28
#define OTF_FUNCTIONGROUPSUMMARY_RECORD	29
#define OTF_MESSAGESUMMARY_RECORD		30

#define OTF_DEFINITIONCOMMENT_RECORD	34

#define OTF_BEGINPROCESS_RECORD			35
#define OTF_ENDPROCESS_RECORD			36

#define OTF_ENTERSNAPSHOT_RECORD		37
#define OTF_SENDSNAPSHOT_RECORD			38

#define OTF_SUMMARYCOMMENT_RECORD		39
#define OTF_SNAPSHOTCOMMENT_RECORD		40

#define OTF_UNKNOWN_RECORD				41


/* Number of records */
#define OTF_NRECORDS					42

/* Stream format definition */

#define OTF_WSTREAM_FORMAT_SHORT		0
#define OTF_WSTREAM_FORMAT_LONG			1


/* Counter properties */

#define OTF_COUNTER_TYPE_BITS		3
#define OTF_COUNTER_TYPE_ACC		0
#define OTF_COUNTER_TYPE_ABS		1

#define OTF_COUNTER_SCOPE_BITS 		12
#define OTF_COUNTER_SCOPE_START 	0
#define OTF_COUNTER_SCOPE_POINT 	4
#define OTF_COUNTER_SCOPE_LAST		8
#define OTF_COUNTER_SCOPE_NEXT		12

#define OTF_COUNTER_PROP_DEFAULT	0


/* Types of collective operations */

#define OTF_COLLECTIVE_TYPE_UNKNOWN 	0
#define OTF_COLLECTIVE_TYPE_BARRIER 	1
#define OTF_COLLECTIVE_TYPE_ONE2ALL 	2
#define OTF_COLLECTIVE_TYPE_ALL2ONE 	3
#define OTF_COLLECTIVE_TYPE_ALL2ALL 	4


/* Level of the z-compression */
#define OTF_ZLEVEL	4


/* return values for handlers. they are not yet evaluated!!! */

#define OTF_RETURN_OK 					1
#define OTF_RETURN_BREAK				0
#define OTF_RETURN_ABORT				0


#endif /* OTF_DEFINITIONS_H */
