/*
 This is part of the OTF library. Copyright by ZIH, TU Dresden 2005-2006.
 Authors: Andreas Knuepfer, Holger Brunst, Ronny Brendel, Thomas Kriebitzsch
*/

#include "hash.h"

hashtabT* hash_new( ) {

	
	int i;
	hashtabT* ret;
	
	ret = ( hashtabT* ) malloc( sizeof( hashtabT ) * HASH_SIZE );
	
	for( i = 0; i < HASH_SIZE; i++) {
	
		ret[i].entry.streamid = 0;
	
		ret[i].entry.ticksPerSecond = 0;
		
		ret[i].entry.functions = NULL;
		ret[i].entry.nfunctions = 0;
		ret[i].entry.sfunctions = 0;
		
		ret[i].entry.functiongroups = NULL;
		ret[i].entry.nfunctiongroups = 0;
		ret[i].entry.sfunctiongroups = 0;
		
		ret[i].entryvecsize = -1;
		ret[i].p_entryvec = 0;
	}
	
	return ret;
}

void hash_delete( hashtabT *hash ) {


	int i;
	
	for( i = 0; i < HASH_SIZE; i++) {
	
		if ( 0 != hash[i].p_entryvec)
			free( hash[i].p_entryvec );
	}
	
	free( hash );
}

void hash_add( hashtabT *hash, uint32_t entry ) {

	uint32_t hashkey = entry;
	
	HASH_GET_KEY( hashkey );
	
	if ( hash[hashkey].entryvecsize == -1 ) {
	
		hash[hashkey].entry.streamid = entry;
		hash[hashkey].entryvecsize = 0;
	
	} else { /* realloc the entryvector and insert the new entry */
	
		hash[hashkey].p_entryvec = (streaminfoT *) realloc( hash[hashkey].p_entryvec,
			sizeof( streaminfoT )* hash[hashkey].entryvecsize + 1);
			
		hash[hashkey].p_entryvec[hash[hashkey].entryvecsize].streamid = entry;
		
		hash[hashkey].entryvecsize++;
		
	}
}

streaminfoT* hash_search( hashtabT *hash, uint32_t entry) {

	int i;
	uint32_t hashkey = entry;
	
	HASH_GET_KEY( hashkey );
	
	if ( hash[hashkey].entry.streamid == entry ) {
		return &hash[hashkey].entry;
	} else {
		for( i = 0; i < hash[hashkey].entryvecsize; i++ ) {
		
			if ( hash[hashkey].p_entryvec[i].streamid == entry )
				return &(hash[hashkey].p_entryvec[i]);
		}
	}
	
	return NULL;
}
