/*
 This is part of the OTF library. Copyright by ZIH, TU Dresden 2005-2006.
 Authors: Andreas Knuepfer, Holger Brunst, Ronny Brendel, Thomas Kriebitzsch
*/

#ifndef _STACK_H
#define _STACK_H

#include <assert.h>
#include "Hash.h"

#include <OTF_Writer.h>

struct struct_StackEntry
{
	int state;
};
typedef struct struct_StackEntry StackEntryT;

struct struct_Stack
{
	/* Stack entries */
	StackEntryT* stack;

	/* Number of entries */
	int n;

	/* Size of the stack */
	int s;
};
typedef struct struct_Stack StackT;

typedef struct {
	char *name;
	StackT *stack;
}processT;

typedef struct {
	uint32_t id;
	uint32_t size;
	uint32_t *procs;
	char* name;
} ProcessGroup;

typedef struct {
	OTF_Writer* writer;
	processT **processes;
	int processcount;
	int *threadnums;
	ProcessGroup *processgroups;
	unsigned int processgroupcount;
	Hash *pghash; /* processgroup-mapping */
	uint32_t *reservedIds;
	int reservedIdsc;
}fcbT;


StackT* Stack_new( void );

void Stack_delete( StackT *stack );

void Stack_push( StackT* stack, StackEntryT* entry );

StackEntryT Stack_pop( StackT* stack );


#endif /* _STACK_H */
